/// Exception class used for internal exception handling
class WebSocketException implements Exception {
  final String originType;
  final String message;
  final String causeMessage;

  WebSocketException(this.originType, this.message, this.causeMessage);

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is WebSocketException &&
          runtimeType == other.runtimeType &&
          originType == other.originType &&
          message == other.message &&
          causeMessage == other.causeMessage;

  @override
  int get hashCode =>
      originType.hashCode ^ message.hashCode ^ causeMessage.hashCode;

  @override
  String toString() =>
      'WebSocketException[type:$originType, message:$message, cause:$causeMessage]';
}
